3 # Copyright (c) 2005, Linus Torvalds
4 # Copyright (c) 2005, Junio C Hamano
6 # Clone a repository into a different directory that does not yet exist.
8 # See git-sh-setup why.
17 die "Usage: $0 [--template=<template_directory>] [--reference <reference-repo>] [--bare] [-l [-s]] [-q] [-u <upload-pack>] [--origin <name>] [--depth <n>] [-n] <repo> [<dir>]"
21 (cd "$1" && (cd .git ; pwd)) 2> /dev/null
24 if [ -n "$GIT_SSL_NO_VERIFY" ]; then
29 # $1 = Remote, $2 = Local
30 curl -nsfL $curl_extra_args "$1" >"$2"
34 # $1 - remote, $2 - local
36 clone_tmp="$GIT_DIR/clone-tmp" &&
37 mkdir -p "$clone_tmp" || exit 1
38 if [ -n "$GIT_CURL_FTP_NO_EPSV" -o \
39 "`git-config --bool http.noEPSV`" = true ]; then
40 curl_extra_args="${curl_extra_args} --disable-epsv"
42 http_fetch "$1/info/refs" "$clone_tmp/refs" ||
43 die "Cannot get remote repository information.
44 Perhaps git-update-server-info needs to be run there?"
45 while read sha1 refname
47 name=`expr "z$refname" : 'zrefs/\(.*\)'` &&
52 yes,* | ,heads/* | ,tags/*) ;;
55 if test -n "$use_separate_remote" &&
56 branch_name=`expr "z$name" : 'zheads/\(.*\)'`
58 tname="remotes/$origin/$branch_name"
62 git-http-fetch -v -a -w "$tname" "$name" "$1/" || exit 1
63 done <"$clone_tmp/refs"
65 http_fetch "$1/HEAD" "$GIT_DIR/REMOTE_HEAD" ||
66 rm -f "$GIT_DIR/REMOTE_HEAD"
85 *,-n|*,--no|*,--no-|*,--no-c|*,--no-ch|*,--no-che|*,--no-chec|\
86 *,--no-check|*,--no-checko|*,--no-checkou|*,--no-checkout)
88 *,--na|*,--nak|*,--nake|*,--naked|\
89 *,-b|*,--b|*,--ba|*,--bar|*,--bare) bare=yes ;;
90 *,-l|*,--l|*,--lo|*,--loc|*,--loca|*,--local) use_local=yes ;;
91 *,-s|*,--s|*,--sh|*,--sha|*,--shar|*,--share|*,--shared)
92 local_shared=yes; use_local=yes ;;
93 1,--template) usage ;;
95 shift; template="--template=$1" ;;
98 *,-q|*,--quiet) quiet=-q ;;
99 *,--use-separate-remote) ;;
100 *,--no-separate-remote)
101 die "clones are always made with separate-remote layout" ;;
102 1,--reference) usage ;;
104 shift; reference="$1" ;;
106 reference=`expr "z$1" : 'z--reference=\(.*\)'` ;;
107 *,-o|*,--or|*,--ori|*,--orig|*,--origi|*,--origin)
112 die "'$2' is not suitable for an origin name"
114 git-check-ref-format "heads/$2" ||
115 die "'$2' is not suitable for a branch name"
116 test -z "$origin_override" ||
117 die "Do not give more than one --origin options."
121 1,-u|1,--upload-pack) usage ;;
122 *,-u|*,--upload-pack)
124 upload_pack="--upload-pack=$1" ;;
126 upload_pack=--upload-pack=$(expr "z$1" : 'z-[^=]*=\(.*\)') ;;
140 die 'you must specify a repository to clone.'
142 # --bare implies --no-checkout and --no-separate-remote
143 if test yes = "$bare"
145 if test yes = "$origin_override"
147 die '--bare and --origin $origin options are incompatible.'
158 # Turn the source into an absolute path if
160 if base=$(get_repo_base "$repo"); then
166 # Try using "humanish" part of source repo if user didn't specify one
167 [ -z "$dir" ] && dir=$(echo "$repo" | sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
168 [ -e "$dir" ] && die "destination directory '$dir' already exists."
170 D=$(cd "$dir" && pwd) &&
171 trap 'err=$?; cd ..; rm -rf "$D"; exit $err' 0
177 esac && export GIT_DIR && git-init ${template+"$template"} || usage
179 if test -n "$reference"
181 if test -d "$reference"
183 if test -d "$reference/.git/objects"
185 reference="$reference/.git"
187 reference=$(cd "$reference" && pwd)
188 echo "$reference/objects" >"$GIT_DIR/objects/info/alternates"
189 (cd "$reference" && tar cf - refs) |
190 (cd "$GIT_DIR/refs" &&
191 mkdir reference-tmp &&
194 find refs ! -type d -print |
199 # Old-style symbolic link ref. Not likely
200 # to appear under refs/ but we might as well
205 point=$(cat "$ref") &&
211 # The above makes true ref to 'continue' and
212 # we will come here when we are looking at
213 # symbolic link ref or a textual symref (or
214 # garbage, like fifo).
215 # The true ref pointed at by it is enough to
216 # ensure that we do not fetch objects reachable
222 die "reference repository '$reference' is not a local directory."
226 rm -f "$GIT_DIR/CLONE_HEAD"
228 # We do local magic only when the user tells us to.
229 case "$local,$use_local" in
231 ( cd "$repo/objects" ) ||
232 die "-l flag seen but repository '$repo' is not local."
234 case "$local_shared" in
236 # See if we can hardlink and drop "l" if not.
237 sample_file=$(cd "$repo" && \
238 find objects -type f -print | sed -e 1q)
240 # objects directory should not be empty since we are cloning!
241 test -f "$repo/$sample_file" || exit
244 if ln "$repo/$sample_file" "$GIT_DIR/objects/sample" 2>/dev/null
248 rm -f "$GIT_DIR/objects/sample" &&
250 find objects -depth -print | cpio -pumd$l "$GIT_DIR/" || exit 1
253 mkdir -p "$GIT_DIR/objects/info"
254 echo "$repo/objects" >> "$GIT_DIR/objects/info/alternates"
257 git-ls-remote "$repo" >"$GIT_DIR/CLONE_HEAD" || exit 1
264 *) die "shallow over rsync not supported" ;;
266 rsync $quiet -av --ignore-existing \
267 --exclude info "$repo/objects/" "$GIT_DIR/objects/" ||
269 # Look at objects/info/alternates for rsync -- http will
270 # support it natively and git native ones will do it on the
271 # remote end. Not having that file is not a crime.
272 rsync -q "$repo/objects/info/alternates" \
273 "$GIT_DIR/TMP_ALT" 2>/dev/null ||
274 rm -f "$GIT_DIR/TMP_ALT"
275 if test -f "$GIT_DIR/TMP_ALT"
278 . git-parse-remote &&
279 resolve_alternates "$repo" <"$GIT_DIR/TMP_ALT" ) |
282 case "$alt" in 'bad alternate: '*) die "$alt";; esac
284 '') echo >&2 "Getting alternate: $alt" ;;
286 rsync $quiet -av --ignore-existing \
287 --exclude info "$alt" "$GIT_DIR/objects" || exit
289 rm -f "$GIT_DIR/TMP_ALT"
291 git-ls-remote "$repo" >"$GIT_DIR/CLONE_HEAD" || exit 1
293 https://*|http://*|ftp://*)
296 *) die "shallow over http or ftp not supported" ;;
298 if test -z "@@NO_CURL@@"
300 clone_dumb_http "$repo" "$D"
302 die "http transport not supported, rebuild Git with curl support"
306 case "$upload_pack" in
307 '') git-fetch-pack --all -k $quiet $depth "$repo" ;;
308 *) git-fetch-pack --all -k $quiet "$upload_pack" $depth "$repo" ;;
309 esac >"$GIT_DIR/CLONE_HEAD" ||
310 die "fetch-pack from '$repo' failed."
315 test -d "$GIT_DIR/refs/reference-tmp" && rm -fr "$GIT_DIR/refs/reference-tmp"
317 if test -f "$GIT_DIR/CLONE_HEAD"
319 # Read git-fetch-pack -k output and store the remote branches.
320 if [ -n "$use_separate_remote" ]
322 branch_top="remotes/$origin"
333 destname="REMOTE_HEAD" ;;
335 destname="refs/$branch_top/${name#refs/heads/}" ;;
337 destname="refs/$tag_top/${name#refs/tags/}" ;;
341 git-update-ref -m "clone: from $repo" "$destname" "$sha1" ""
342 done < "$GIT_DIR/CLONE_HEAD"
347 if test -z "$bare" && test -f "$GIT_DIR/REMOTE_HEAD"
349 # a non-bare repository is always in separate-remote layout
350 remote_top="refs/remotes/$origin"
351 head_sha1=`cat "$GIT_DIR/REMOTE_HEAD"`
354 # Uh-oh, the remote told us (http transport done against
355 # new style repository with a symref HEAD).
356 # Ideally we should skip the guesswork but for now
357 # opt for minimum change.
358 head_sha1=`expr "z$head_sha1" : 'zref: refs/heads/\(.*\)'`
359 head_sha1=`cat "$GIT_DIR/$remote_top/$head_sha1"`
363 # The name under $remote_top the remote HEAD seems to point at.
366 test -f "$GIT_DIR/$remote_top/master" && echo "master"
367 cd "$GIT_DIR/$remote_top" &&
368 find . -type f -print | sed -e 's/^\.\///'
373 test t = $done && continue
374 branch_tip=`cat "$GIT_DIR/$remote_top/$name"`
375 if test "$head_sha1" = "$branch_tip"
384 # Write out remote.$origin config, and update our "$head_points_at".
385 case "$head_points_at" in
387 # Local default branch
388 git-symbolic-ref HEAD "refs/heads/$head_points_at" &&
390 # Tracking branch for the primary branch at the remote.
391 origin_track="$remote_top/$head_points_at" &&
392 git-update-ref HEAD "$head_sha1" &&
395 git-config remote."$origin".url "$repo" &&
397 # Set up the mappings to track the remote branches.
398 git-config remote."$origin".fetch \
399 "+refs/heads/*:$remote_top/*" '^$' &&
400 rm -f "refs/remotes/$origin/HEAD"
401 git-symbolic-ref "refs/remotes/$origin/HEAD" \
402 "refs/remotes/$origin/$head_points_at" &&
404 git-config branch."$head_points_at".remote "$origin" &&
405 git-config branch."$head_points_at".merge "refs/heads/$head_points_at"
408 case "$no_checkout" in
410 test "z$quiet" = z && v=-v || v=
411 git-read-tree -m -u $v HEAD HEAD
414 rm -f "$GIT_DIR/CLONE_HEAD" "$GIT_DIR/REMOTE_HEAD"